//*****************************************************************************
//*****************************************************************************
//  FILENAME: BPF_1.h
//   Version: 5.3, Updated on 2006/01/21 at 06:21:44
//  Generated by PSoC Designer ver 4.3  b1884 : 23 June, 2006
//
//  DESCRIPTION: C declarations for the BPF2 User Module.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems YYYY. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 BPF_1_Start
#pragma fastcall16 BPF_1_SetPower
#pragma fastcall16 BPF_1_Stop
#pragma fastcall16 BPF_1_SetC1
#pragma fastcall16 BPF_1_SetC2
#pragma fastcall16 BPF_1_SetC3
#pragma fastcall16 BPF_1_SetC4
#pragma fastcall16 BPF_1_SetCA
#pragma fastcall16 BPF_1_SetCB
#pragma fastcall16 BPF_1_SetPolarity


//-------------------------------------------------
// Prototypes of the BPF_1 API.
//-------------------------------------------------

extern void BPF_1_Start(BYTE bPowerSetting);
extern void BPF_1_SetPower(BYTE bPowerSetting);
extern void BPF_1_Stop(void);
extern void BPF_1_SetC1(BYTE bCapValue);
extern void BPF_1_SetC2(BYTE bCapValue);
extern void BPF_1_SetC3(BYTE bCapValue);
extern void BPF_1_SetC4(BYTE bCapValue);
extern void BPF_1_SetCA(BYTE bCapValue);
extern void BPF_1_SetCB(BYTE bCapValue);
extern void BPF_1_SetPolarity(BYTE bPolaritySetting);


//-------------------------------------------------
// Defines for BPF_1 API's.
//-------------------------------------------------

#define BPF_1_OFF                                (0x00)
#define BPF_1_LOWPOWER                           (0x01)
#define BPF_1_MEDPOWER                           (0x02)
#define BPF_1_HIGHPOWER                          (0x03)

#define BPF_1_FEEDBACK_16                        (0x00)
#define BPF_1_FEEDBACK_32                        (0x01)

#define BPF_1_POLARITY_INVERTING                 (0x00)
#define BPF_1_POLARITY_NON_INVERTING             (0x01)

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------

#pragma ioport  BPF_1_FLIN_CR0: 0x094                       //Analog SCA control register 0
BYTE            BPF_1_FLIN_CR0;
#pragma ioport  BPF_1_FLIN_CR1: 0x095                       //Analog SCA control register 1
BYTE            BPF_1_FLIN_CR1;
#pragma ioport  BPF_1_FLIN_CR2: 0x096                       //Analog SCA control register 2
BYTE            BPF_1_FLIN_CR2;
#pragma ioport  BPF_1_FLIN_CR3: 0x097                       //Analog SCA control register 3
BYTE            BPF_1_FLIN_CR3;
#pragma ioport  BPF_1_FLFB_CR0: 0x090                       //Analog SCB control register 0
BYTE            BPF_1_FLFB_CR0;
#pragma ioport  BPF_1_FLFB_CR1: 0x091                       //Analog SCB control register 1
BYTE            BPF_1_FLFB_CR1;
#pragma ioport  BPF_1_FLFB_CR2: 0x092                       //Analog SCB control register 2
BYTE            BPF_1_FLFB_CR2;
#pragma ioport  BPF_1_FLFB_CR3: 0x093                       //Analog SCB control register 3
BYTE            BPF_1_FLFB_CR3;

//  BPF_1 Cap naming convention per Gregorian and Temes, p293

#pragma ioport  BPF_1_FILT_C1_REG:  0x094
BYTE            BPF_1_FILT_C1_REG;
#pragma ioport  BPF_1_FILT_C2_REG:  0x095
BYTE            BPF_1_FILT_C2_REG;
#pragma ioport  BPF_1_FILT_C3_REG:  0x090
BYTE            BPF_1_FILT_C3_REG;
#pragma ioport  BPF_1_FILT_C4_REG:  0x092
BYTE            BPF_1_FILT_C4_REG;
#pragma ioport  BPF_1_FILT_CA_REG:  0x094
BYTE            BPF_1_FILT_CA_REG;
#pragma ioport  BPF_1_FILT_CB_REG:  0x090
BYTE            BPF_1_FILT_CB_REG;


// end of file BPF_1.h
