;main_synth.asm 
;     ( )



include "m8c.inc"
include "memory.inc"
include "PSoCAPI.inc"   ; PSoC API definitions for all User Modules

AREA InterruptRAM (RAM,REL,CON)
a1:		BLK	1	; 
a2:		BLK	1	;
apw:	BLK	1	;
asw:	BLK	1	;


AREA UserModules (ROM, REL)
;-----------------------------------------------------------------------------
;  DESCRIPTION:	          
;
;  ARGUMENTS:	[pitchRange]	 : 0 - , 1 - , 2 - , 3 - 
;				[pitchVoice]	  0...11
;
;  RETURNS:		[refFreq]
;-----------------------------------------------------------------------------
macro loadA
;  A ,       "a1",  
	mov A,[a1]
	inc [a1]
 	index voiceTable
endm

setConfiguration::
	; -  .       16
	mov A,[pitchVoice]
	asl A
	asl A
	asl A
	asl A
	mov [a1],A	;   

	;---  
	loadA			; ID  
	cmp A,0
	;jnz qqqqq		; ID  0
	
	
	
	;---    -      "refFreq"
	;         
	;      ,     -   (    )
	call setPitchRange

	;---      - .. ""      
	;   (     = k *   /16, k=1...8)
	;        [a2]
	;    k=1...8   (   = 1/16 ... 8/16  )
	loadA			; "" (k=1...8)  
	mov [apw],A		;    . 
	mov X,A			;  X
	mov A,0			;   
	.rep:
		add A,[a2]							; 
		dec X
		jnz .rep							;    
	rrc A									;/16 
	asr A 
	asr A 
	asr A
	jnz .nozero
		inc A 	; 0,    1 ( ) 
	.nozero:
	mov reg[Counter8_2_COMPARE_REG],A		;     -

	;---      " " (0 - . , 1 -   , 2 -  )
	;                         "pitchRange"=0            "pitchRange"=1            "pitchRange"=2            "pitchRange"=3 
	;                            F=94                  F=188                   F=375                  F=750  
	;"0 - . "      f= 90 ("A"=2)       f=300 ("A"=1)         f=300 ("A"=1)        f=600 ("A"=0)
	;"1 -  "   f=300 ("A"=1)       f=300 ("A"=1)         f=600 ("A"=0)        f=600 ("A"=0)
	;"2 -  "   f=600 ("A"=0)       f=600 ("A"=0)         f=600 ("A"=0)        f=600 ("A"=0)
	loadA				; " " (0...2)  
	mov [asw],A			;    . 
	asl A				;x4
	asl A				;
	add A,[pitchRange]	;     
	index AA			;   -> A
	call setCap			;  

	;---  .       
	call gainCorrection

	;---    
	loadA				;  (0...7)    
	asl A				;     
	asl A				;     
	asl A				;   
	asl A				;   "modindex"
	asl A				;   ( 7...5 -  ,  4...0 )
	mov [modindex],A	;   "modindex" 


	;---     ()
setReg:
	;    
	mov A,[a1]
  	and A,0b00001111	;  
	index   addr
	mov     X,A			;  X
	;    
	mov   A,[a1]
	index voiceTable
  	and A,0b00011111	;  
	mov   [a2],A		;  
	; 
    mov A,reg[X]		;  
    and A,0b11100000	; 
    or A,[a2]			; 
    mov reg[X],A		;   
	;
	inc [a1]
	tst [a1],0b00001111 
	jnz setReg			;   
	ret

.LITERAL	
voiceTable:       ;  (12   16 )
	; ID  .  . ----BPF1---   -----LPF1-----   -----LPF2-----
	;     (1..8)  (0..2)  (0..7)  C1 C2 C3 C4   C1  C2  C3  C4   C1  C2  C3  C4
	DB 0,    8,     0,     0,     0, 1, 31,31,   8,  8, 31, 31,   8,  8, 31, 31 ; , 
	DB 0,    8,     1,     0,     0, 1, 31,31,   8,  8, 31, 31,   8,  8, 31, 31 ; , .
	DB 0,    8,     2,     0,     0, 1, 31,31,   8,  8, 31, 31,   8,  8, 31, 31 ; , . 
	DB 0,    3,     1,     0,     0, 1, 31,31,   8,  8, 31, 31,   8,  8, 31, 31 ; , .
	DB 0,    3,     2,     5,     0, 1, 31,31,   8,  8, 31, 31,   8,  8, 31, 31 ; , . ,  5
	DB 0,    3,     2,     7,     0, 1, 31,31,   8,  8, 31, 31,   8,  8, 31, 31 ; , . ,  7
	DB 0,    5,     1,     0,     1, 1,  1, 8,   9, 14,  6, 4,    4,  5,  6,  6 ;500 4600 2700  ""
	DB 0,    5,     1,     0,     1, 1,  1, 8,   4,  5,  6, 6,    1,  3,  1,  8 ;500 2700 850   ""
	DB 0,    5,     1,     0,     1, 2,  1, 8,  12, 18,  2, 8,    2,  3,  2, 10 ;700 3000 1200  ""
	DB 0,    5,     1,     5,     2, 3,  2, 8,  12, 18,  2, 8,   18, 24,  1, 31 ;1200 3000 2400  "" 
	DB 0,    5,     2,     0,     2, 3,  2, 8,  20, 31,  3, 6,   18, 24,  1, 31 ;1200 4900 2400  
	DB 0,    3,     2,     5,     2, 3,  2, 8,  20, 31,  3, 6,   18, 24,  1, 31 ;1200 4900 2400  ,  5

addr:	;  12    BPF1, LPF1, LPF2 (  4  )    
	DB	F7h,                    F7h,                    F7h,                    F7h
	DB	BPF_1_FILT_C1_REG,    	BPF_1_FILT_C2_REG,    	BPF_1_FILT_C3_REG,    	BPF_1_FILT_C4_REG
	DB	LPF_1_FILT_C1_REG,    	LPF_1_FILT_C2_REG,    	LPF_1_FILT_C3_REG,    	LPF_1_FILT_C4_REG
	DB	LPF_2_FILT_C1_REG,    	LPF_2_FILT_C2_REG,    	LPF_2_FILT_C3_REG,    	LPF_2_FILT_C4_REG

AA:	;  12    "setCap" (      ) 
	;   "pitchRange"=0  "pitchRange"=1  "pitchRange"=2  "pitchRange"=3
	DB       2,              1,              1,              0   ;"0 - . "
	DB       1,              1,              0,              0   ;"1 -  "
	DB       0,              0,              0,              0   ;"2 -  "
.ENDLITERAL		



;-----------------------------------------------------------------------------
;  DESCRIPTION:	     .       "refFreq"
;               
;  ARGUMENTS:	[pitchRange]	=0 - 		k1,k2 = 16,64
;				 				=1  - 		k1,k2 = 8, 32
;				 				=2  - 		k1,k2 = 4, 16
;								=3  - 	k1,k2 = 2, 8
;  RETURNS:		[refFreq]	- 5    
;				[a2]		- ,     -  
;-----------------------------------------------------------------------------
setPitchRange::
	mov A, [pitchRange]					; 
	asl A
	asl A
	asl A
	mov X,A								;  

	mov A,X
	index setR+0						;    ()    
	mov [a2],A							;   
	dec A								;
	mov reg[Counter8_2_PERIOD_REG],A	;  

	mov A,X
	index setR+1						;   . ()    	
	mov reg[Counter8_2_COMPARE_REG],A	;  

	mov A,X
	index setR+2						;    ()   ()  
	dec A								;
	mov reg[Counter8_4_PERIOD_REG],A	;  
	
	mov A,X
	index setR+3	
	mov [refFreq+0],A					;     5     
	mov A,X
	index setR+4	
	mov [refFreq+1],A
	mov A,X
	index setR+5	
	mov [refFreq+2],A
	mov A,X
	index setR+6	
	mov [refFreq+3],A
	mov A,X
	index setR+7	
	mov [refFreq+4],A
	ret
;4      
.LITERAL	
;	   Counter8_2(Period)	Counter8_2_COMPARE	Counter8_4(Period)			refFreq   
setR:	DB	16,						4,					64,			1Ch, 4Eh,  Eh, 0, 0	;   937 500= E 4E 1C   
		DB	8,						2,					32,			38h, 9Ch, 1Ch, 0, 0	; 1 875 000=1C 9C 38   
		DB	4,						1,					16,			70h, 38h, 39h, 0, 0	; 3 750 000=39 38 70   
		DB	2,						1,					8,			E0h, 70h, 72h, 0, 0	;75 000 000=72 70 E0   
.ENDLITERAL		

;-----------------------------------------------------------------------------
;  DESCRIPTION:	  P1[3]  P1[5]    (   )
;               
;  ARGUMENTS:	[A]	0 -  . ,       f=600
;				 	1  -  470pF  P1[5],  f=300
;				 	2  -  6800pF  P1[3], f=90
;					3  -               f=85
;  RETURNS:		
;-----------------------------------------------------------------------------
setCap::
		;P1[3]-6800pF P1[5]-470pF   
	    M8C_SetBank1
		and  reg[PRT1DM0],0b11010111 ;DM2.DM1.DM0 = "110" - all High Impedance 
		or   reg[PRT1DM1],0b00101000 
		or   reg[PRT1DM2],0b00101000 
		rrc A
		jnc .n1
			xor  reg[PRT1DM0],0b00100000 ;DM2.DM1.DM0 = "001" - P1[5] Strong
			xor  reg[PRT1DM1],0b00100000
			xor  reg[PRT1DM2],0b00100000
			jmp .n2
	.n1:rrc A
		jnc .n2
			xor  reg[PRT1DM0],0b00001000 ;DM2.DM1.DM0 = "001" - P1[3] Strong
			xor  reg[PRT1DM1],0b00001000
			xor  reg[PRT1DM2],0b00001000
	.n2:M8C_SetBank0
		ret
;-----------------------------------------------------------------------------
;  DESCRIPTION:	    (   SCB)
;               
;  ARGUMENTS:	[A]	-  ,   0
;  RETURNS:		
;-----------------------------------------------------------------------------
;  !
setFilterbank::
	;    ( 4  = 0).  4  -  .
	asl A
	asl A
	asl A
	asl A
	mov [a1],A			;  
set:
	;    
	mov A,[a1]
  	and A,0b00001111	;  
	index   addr2
	mov     X,A
	;    
	mov   A,[a1]
	index set00
  	and A,0b00011111	;  
	mov   [a2],A		; 
	; 
    mov A,reg[X]		;  
    and A,0b11100000	; 
    or A,[a2]			; 
    mov reg[X],A		;   
	;
	inc [a1]
	tst [a1],0b00001111 
	jnz set				;   16- 
	
	ret

;   	
.LITERAL	
;16   ( BPF1, LPF1, LPF2, SCB1  SCB2)  
addr2:DB BPF_1_FILT_C1_REG,    	BPF_1_FILT_C2_REG,    	BPF_1_FILT_C3_REG,    	BPF_1_FILT_C4_REG
	 DB	LPF_1_FILT_C1_REG,    	LPF_1_FILT_C2_REG,    	LPF_1_FILT_C3_REG,    	LPF_1_FILT_C4_REG
	 DB	LPF_2_FILT_C1_REG,    	LPF_2_FILT_C2_REG,    	LPF_2_FILT_C3_REG,    	LPF_2_FILT_C4_REG
	 DB	SCBLOCK_1_cr0,			SCBLOCK_1_cr1,			SCBLOCK_2_cr0,			SCBLOCK_2_cr1
;	 DB	F7h,	F7h,	F7h,	F7h
;  16 .
;		        BPF1         LPF1           LPF2        SCB1    SCB2
;		   C1 C2 C3 C4    C1 C2 C3 C4    C1 C2 C3 C4    CA CB   CA CB   
set00:	DB 1, 2, 1, 8,   12, 18, 2, 8,   2, 3, 2, 10,   31,31,  31,0 ; ""
;		DB 1, 2, 1, 8,   12, 18, 2, 8,   2, 3, 2, 10,   31,31,  31,0 ; "" >9
		DB 2, 3, 2, 8,   18, 24, 1, 31,  20, 31, 3, 6,  31,31,  31,0 ;
		DB 1, 1, 1, 8,    9, 14, 6, 4,    4, 5, 6, 6,   31,31,  31,0 ;
.ENDLITERAL		

;-----------------------------------------------------------------------------
;  DESCRIPTION:	  PGA_1,    
;               
;  ARGUMENTS:	[pitchRange]=0..3
;				[apw]=1..8 ("")
;				[asw]=0..2 ("")
;  RETURNS:		    PGA_1
;48_0  24_0  16_0  8_00  5_33  4_00  3_20  2_67  2_27  2_00  1_78  1_60  1_46  1_33  1_23  1_14  1_06
;1_00  0_93  0_87  0_81  0_75  0_68  0_62  0_56  0_50  0_43  0_37  0_31  0_25  0_18  0_12  0_06
;-----------------------------------------------------------------------------
gainCorrection:
	mov A,PGA_1_G0_75	; 

	cmp [pitchRange],3
	jnz .n1
		; "pitchRange"=3
		mov A,PGA_1_G0_87;PGA_1_G1_06
		jmp .n99 
	.n1:
	cmp [pitchRange],2
	jnz .n2
		; "pitchRange"=2
		mov A,PGA_1_G0_75
		cmp [asw],0
		jnz .n99
			; ""=0
			mov A,PGA_1_G0_81
			cmp [apw],5
			jnc .n99
				; ""<5
				mov A,PGA_1_G0_93
				jmp .n99 
	.n2:
	cmp [pitchRange],1
	jnz .n3
		; "pitchRange"=1
		mov A,PGA_1_G0_68
		cmp [asw],2
		jz .n99
			; ""=0,1
			cmp [apw],3
			jnc .n99
				;  ""<3
				mov A,PGA_1_G0_87
				jmp .n99 
	.n3:
		; "pitchRange"=0
		mov A,[asw]	; "" 0..2  
		cmp [apw],5
		jc .n4
			; "">4
			index pw8
			jmp .n99
		.n4: 
		cmp [apw],3
		jc .n5
			; "">2
			index pw4
			jmp .n99
		.n5: 
		cmp [apw],2
		jc .n6
			; "">1
			index pw2
			jmp .n99
		.n6: 
		; ""=1,0
			index pw1
			jmp .n99

	.n99:
	lcall PGA_1_SetGain
	ret

.LITERAL	; .  "pitchRange"=0
pw8: DB PGA_1_G1_00,    PGA_1_G0_62,    PGA_1_G0_81
pw4: DB PGA_1_G1_23,    PGA_1_G0_62,    PGA_1_G0_68
pw2: DB PGA_1_G1_78,    PGA_1_G0_62,    PGA_1_G0_75
pw1: DB PGA_1_G3_20,    PGA_1_G0_93,    PGA_1_G0_81
.ENDLITERAL		

;end of main_proc.asm 
