;==========================================================
; "to_lcd_itoa.inc"
;
; Macros for "toLCD" routines
; Refer "toLCD.asm" for LCD Port Number and full code
;==========================================================

;below are the procedures (not macros!) located in toLCD.asm
;lcall  LCD_Start/LCD_Init
;lcall  LCD_WriteData
;lcall  LCD_Control
;lcall  LCD_Delay50uTimes
;lcall  LCD_Delay50u
;lcall  LCD_PrHexByte

;================================================
;toLCD_PrHexInt (label of var)
macro toLCD_PrHexInt ;@0
	mov A,[@0+0]
	mov	X,[@0+1]
	lcall LCD_PrHexInt
endm
;================================================
;toLCD_String (row,col,"string") (row,col=0,1...)
macro toLCD_String ;@0,@1,@2
	mov A,@0
	mov	X,@1
	lcall LCD_Position
	mov A,>.string
	mov	X,<.string
	lcall LCD_PrCString
	jmp .end
	.LITERAL
	.string:
	ASCIZ @2
	.ENDLITERAL
	.end:
endm
;================================================
;toLCD_PrCString (label of ROM)
macro toLCD_PrCString ;@0
	mov A,>@0
	mov	X,<@0
	lcall LCD_PrCString
endm
;================================================
;toLCD_PrString (label of RAM)
macro toLCD_PrString ;@0
	mov A,>@0
	mov	X,<@0
	lcall LCD_PrString
endm
;================================================
;toLCD_Position (row,col)
macro toLCD_Position ;@0,@1
	mov A,@0
	mov	X,@1
	lcall LCD_Position
endm
;===================== my proc ==================
;toLCD_itoa8 (var),length
;					=1..15  length of string (value is left justified, right spaces are added)
;					=0      fixed length =13 (value is right justified, left unsigned zeros are added)
macro toLCD_itoa8 ;@0,@1
	mov [itoa_Integer+0],[@0+0]
	lcall itoa_i8
	mov [itoa_Length],@1
	lcall itoa_format
	mov A,>itoa_String
	mov	X,<itoa_String
	lcall LCD_PrString
endm
;================================================
;toLCD_itoa16 (var),length
;					=1..15  length of string (value is left justified, right spaces are added)
;					=0      fixed length =13 (value is right justified, left unsigned zeros are added)
macro toLCD_itoa16 ;@0,@1
	mov [itoa_Integer+0],[@0+0]
	mov [itoa_Integer+1],[@0+1]
	lcall itoa_i16
	mov [itoa_Length],@1
	lcall itoa_format
	mov A,>itoa_String
	mov	X,<itoa_String
	lcall LCD_PrString
endm
;================================================
;toLCD_itoa24 (var),length
;					=1..15  length of string (value is left justified, right spaces are added)
;					=0      fixed length =13 (value is right justified, left unsigned zeros are added)
macro toLCD_itoa24 ;@0,@1
	mov [itoa_Integer+0],[@0+0]
	mov [itoa_Integer+1],[@0+1]
	mov [itoa_Integer+2],[@0+2]
	lcall itoa_i24
	mov [itoa_Length],@1
	lcall itoa_format
	mov A,>itoa_String
	mov	X,<itoa_String
	lcall LCD_PrString
endm
;================================================
;toLCD_itoa32 (var),length
;					=1..15  length of string (value is left justified, right spaces are added)
;					=0      fixed length =13 (value is right justified, left unsigned zeros are added)
macro toLCD_itoa32 ;@0,@1
	mov [itoa_Integer+0],[@0+0]
	mov [itoa_Integer+1],[@0+1]
	mov [itoa_Integer+2],[@0+2]
	mov [itoa_Integer+3],[@0+3]
	lcall itoa_i32
	mov [itoa_Length],@1
	lcall itoa_format
	mov A,>itoa_String
	mov	X,<itoa_String
	lcall LCD_PrString
endm
;================================================
;toLCD_itoa40 (var),length
;					=1..15  length of string (value is left justified, right spaces are added)
;					=0      fixed length =13 (value is right justified, left unsigned zeros are added)
macro toLCD_itoa40 ;@0,@1
	mov [itoa_Integer+0],[@0+0]
	mov [itoa_Integer+1],[@0+1]
	mov [itoa_Integer+2],[@0+2]
	mov [itoa_Integer+3],[@0+3]
	mov [itoa_Integer+4],[@0+4]
	lcall itoa_i40
	mov [itoa_Length],@1
	lcall itoa_format
	mov A,>itoa_String
	mov	X,<itoa_String
	lcall LCD_PrString
endm
;================================================
;toLCD_strCopy string1, string2
;	Copies string2 to string1
;	Returns in X number of non-zero chars
macro toLCD_strCopy ;@0,@1
	mov X,0
	.repeat:
		mov        A,[X+@1]
		mov [X+@0],A
		jz .end
		inc X
		jmp .repeat
	.end: 
endm
;================================================








